package com.nisum.offertransactionservice.dao;

import com.nisum.offertransactionservice.model.OfferTransactionRequest;
import com.nisum.offertransactionservice.model.OfferTransactionResponse;
import com.nisum.offertransactionservice.model.PERequest;
import com.nisum.offertransactionservice.model.PEResponse;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.PropertySource;
import org.springframework.stereotype.Component;
import org.springframework.http.*;
import org.springframework.web.client.*;

@Component
@PropertySource("classpath:application.properties")
public class OfferDao {

    @Autowired
    private RestTemplate restTemplate;

    @Value("${promotion.engine.calculate.discount.url}")
    private String promotionEngineUrl ;

    public PEResponse callPE(PERequest peRequest) {
        ResponseEntity<PEResponse> peResponse = restTemplate.postForEntity("http://localhost:8081"+promotionEngineUrl,peRequest,PEResponse.class);
        return peResponse.getBody();
    }
}
